<html>
<head>
<title>OgreGLES2RenderSystem.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_43d9b0265a5a2fd53bf3892a292ce5e9.html">RenderSystems</a>      </li>
      <li class="navelem"><a class="el" href="dir_740c5ae02f3e58539fc77518d7d26661.html">GLES2</a>      </li>
      <li class="navelem"><a class="el" href="dir_03408e7e26591a021d5048c9e4238005.html">include</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">OgreGLES2RenderSystem.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="OgreGLES2RenderSystem_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">    (Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2012 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">Permission is hereby granted, free of charge, to any person obtaining a copy</span>
<a name="l00010"></a>00010 <span class="comment">of this software and associated documentation files (the &quot;Software&quot;), to deal</span>
<a name="l00011"></a>00011 <span class="comment">in the Software without restriction, including without limitation the rights</span>
<a name="l00012"></a>00012 <span class="comment">to use, copy, modify, merge, publish, distribute, sublicense, and/or sell</span>
<a name="l00013"></a>00013 <span class="comment">copies of the Software, and to permit persons to whom the Software is</span>
<a name="l00014"></a>00014 <span class="comment">furnished to do so, subject to the following conditions:</span>
<a name="l00015"></a>00015 <span class="comment"></span>
<a name="l00016"></a>00016 <span class="comment">The above copyright notice and this permission notice shall be included in</span>
<a name="l00017"></a>00017 <span class="comment">all copies or substantial portions of the Software.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR</span>
<a name="l00020"></a>00020 <span class="comment">IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,</span>
<a name="l00021"></a>00021 <span class="comment">FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE</span>
<a name="l00022"></a>00022 <span class="comment">AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER</span>
<a name="l00023"></a>00023 <span class="comment">LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,</span>
<a name="l00024"></a>00024 <span class="comment">OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN</span>
<a name="l00025"></a>00025 <span class="comment">THE SOFTWARE.</span>
<a name="l00026"></a>00026 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00027"></a>00027 <span class="comment">*/</span>
<a name="l00028"></a>00028 
<a name="l00029"></a>00029 <span class="preprocessor">#ifndef __GLES2RenderSystem_H__</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span><span class="preprocessor">#define __GLES2RenderSystem_H__</span>
<a name="l00031"></a>00031 <span class="preprocessor"></span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="OgreGLES2Prerequisites_8h.html">OgreGLES2Prerequisites.h</a>&quot;</span>
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 <span class="preprocessor">#include &quot;<a class="code" href="OgreMaterialManager_8h.html">OgreMaterialManager.h</a>&quot;</span>
<a name="l00035"></a>00035 <span class="preprocessor">#include &quot;<a class="code" href="OgreRenderSystem_8h.html">OgreRenderSystem.h</a>&quot;</span>
<a name="l00036"></a>00036 <span class="preprocessor">#include &quot;<a class="code" href="OgreGLES2GpuProgram_8h.html">OgreGLES2GpuProgram.h</a>&quot;</span>
<a name="l00037"></a>00037 
<a name="l00038"></a>00038 <span class="keyword">namespace </span>Ogre {
<a name="l00039"></a>00039     <span class="keyword">class </span>GLES2Context;
<a name="l00040"></a>00040     <span class="keyword">class </span>GLES2Support;
<a name="l00041"></a>00041     <span class="keyword">class </span>GLES2RTTManager;
<a name="l00042"></a>00042     <span class="keyword">class </span>GLES2GpuProgramManager;
<a name="l00043"></a>00043     <span class="keyword">class </span>GLSLESProgramFactory;
<a name="l00044"></a>00044 <span class="preprocessor">#if !OGRE_NO_GLES2_CG_SUPPORT</span>
<a name="l00045"></a>00045 <span class="preprocessor"></span>    <span class="keyword">class </span>GLSLESCgProgramFactory;
<a name="l00046"></a>00046 <span class="preprocessor">#endif</span>
<a name="l00047"></a>00047 <span class="preprocessor"></span>    <span class="keyword">class </span>GLSLESGpuProgram;
<a name="l00048"></a>00048     <span class="keyword">class </span>HardwareBufferManager;
<a name="l00049"></a>00049 
<a name="l00053"></a><a class="code" href="classOgre_1_1GLES2RenderSystem.html">00053</a>     <span class="keyword">class </span><a class="code" href="OgreGLES2Prerequisites_8h.html#a3f2e060c56216a4f3fb7650e502f5735">_OgreGLES2Export</a> <a class="code" href="classOgre_1_1GLES2RenderSystem.html" title="Implementation of GL ES 2.x as a rendering system.">GLES2RenderSystem</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1RenderSystem.html" title="Defines the functionality of a 3D API.">RenderSystem</a>
<a name="l00054"></a>00054     {
<a name="l00055"></a>00055         <span class="keyword">private</span>:
<a name="l00056"></a><a class="code" href="classOgre_1_1GLES2RenderSystem.html#a8d12f2d55f7e1ac3b4e5b6c200a9322f">00056</a>             <span class="keyword">typedef</span> HashMap&lt;GLenum, GLuint&gt;  <a class="code" href="classOgre_1_1GLES2RenderSystem.html#a8d12f2d55f7e1ac3b4e5b6c200a9322f">BindBufferMap</a>;
<a name="l00057"></a>00057 
<a name="l00059"></a><a class="code" href="classOgre_1_1GLES2RenderSystem.html#a83d4affe2d2c346e95831c9b19e5862c">00059</a>             <a class="code" href="classOgre_1_1Matrix4.html" title="Class encapsulating a standard 4x4 homogeneous matrix.">Matrix4</a> <a class="code" href="classOgre_1_1GLES2RenderSystem.html#a83d4affe2d2c346e95831c9b19e5862c" title="View matrix to set world against.">mViewMatrix</a>;
<a name="l00060"></a><a class="code" href="classOgre_1_1GLES2RenderSystem.html#a684436fa5a448465757fca82d5116597">00060</a>             <a class="code" href="classOgre_1_1Matrix4.html" title="Class encapsulating a standard 4x4 homogeneous matrix.">Matrix4</a> <a class="code" href="classOgre_1_1GLES2RenderSystem.html#a684436fa5a448465757fca82d5116597">mWorldMatrix</a>;
<a name="l00061"></a><a class="code" href="classOgre_1_1GLES2RenderSystem.html#ae43f42d17ad783673bd0b074dd9b3910">00061</a>             <a class="code" href="classOgre_1_1Matrix4.html" title="Class encapsulating a standard 4x4 homogeneous matrix.">Matrix4</a> <a class="code" href="classOgre_1_1GLES2RenderSystem.html#ae43f42d17ad783673bd0b074dd9b3910">mTextureMatrix</a>;
<a name="l00062"></a>00062 
<a name="l00064"></a><a class="code" href="classOgre_1_1GLES2RenderSystem.html#a984c45f718fdb39abc4d48eb194250ba">00064</a>             <a class="code" href="group__General.html#ga02306c6246268d35f45ad22278bd5d3d" title="Filtering options for textures / mipmaps.">FilterOptions</a> <a class="code" href="classOgre_1_1GLES2RenderSystem.html#a984c45f718fdb39abc4d48eb194250ba" title="Last min &amp; mip filtering options, so we can combine them.">mMinFilter</a>;
<a name="l00065"></a><a class="code" href="classOgre_1_1GLES2RenderSystem.html#a7b7150f4735e06acb37a645a6f1301ad">00065</a>             <a class="code" href="group__General.html#ga02306c6246268d35f45ad22278bd5d3d" title="Filtering options for textures / mipmaps.">FilterOptions</a> <a class="code" href="classOgre_1_1GLES2RenderSystem.html#a7b7150f4735e06acb37a645a6f1301ad">mMipFilter</a>;
<a name="l00066"></a>00066 
<a name="l00068"></a><a class="code" href="classOgre_1_1GLES2RenderSystem.html#a3577aee0c7697a5c43be3bd135bca11e">00068</a>             <span class="keywordtype">size_t</span> mTextureCoordIndex[<a class="code" href="OgreConfig_8h.html#a1c5fd80e6e0f2f85d6facbe1ec8eb5a4" title="Define max number of texture layers allowed per pass on any card.">OGRE_MAX_TEXTURE_LAYERS</a>];
<a name="l00069"></a>00069 
<a name="l00071"></a><a class="code" href="classOgre_1_1GLES2RenderSystem.html#af8d404666957fcd7a056b0e6d35b9108">00071</a>             GLenum mTextureTypes[<a class="code" href="OgreConfig_8h.html#a1c5fd80e6e0f2f85d6facbe1ec8eb5a4" title="Define max number of texture layers allowed per pass on any card.">OGRE_MAX_TEXTURE_LAYERS</a>];
<a name="l00072"></a>00072 
<a name="l00074"></a><a class="code" href="classOgre_1_1GLES2RenderSystem.html#aa2460ea67fba93866699608d8715b418">00074</a>             <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> <a class="code" href="classOgre_1_1GLES2RenderSystem.html#aa2460ea67fba93866699608d8715b418" title="Number of fixed-function texture units.">mFixedFunctionTextureUnits</a>;
<a name="l00075"></a>00075 
<a name="l00077"></a><a class="code" href="classOgre_1_1GLES2RenderSystem.html#ad3ef3d02307d5b360f167642816a74e8">00077</a>             <span class="keywordtype">bool</span> mColourWrite[4];
<a name="l00078"></a>00078 
<a name="l00080"></a><a class="code" href="classOgre_1_1GLES2RenderSystem.html#a88e0efd042a0003967157c687eec56bc">00080</a>             <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1GLES2RenderSystem.html#a88e0efd042a0003967157c687eec56bc" title="Store last depth write state.">mDepthWrite</a>;
<a name="l00081"></a>00081 
<a name="l00083"></a><a class="code" href="classOgre_1_1GLES2RenderSystem.html#acde2de48a8bfd4f96497a44b88800864">00083</a>             <a class="code" href="namespaceOgre.html#adf2a0cf2e77143b5ee1d38a75e289545">uint32</a> <a class="code" href="classOgre_1_1GLES2RenderSystem.html#acde2de48a8bfd4f96497a44b88800864" title="Store last stencil mask state.">mStencilMask</a>;
<a name="l00084"></a>00084 
<a name="l00085"></a><a class="code" href="classOgre_1_1GLES2RenderSystem.html#a43e81089513fe9564bc754860bffc609">00085</a>             GLfloat mAutoTextureMatrix[16];
<a name="l00086"></a>00086 
<a name="l00087"></a><a class="code" href="classOgre_1_1GLES2RenderSystem.html#a2152ac327a27c4300a70795c90dbde2d">00087</a>             <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1GLES2RenderSystem.html#a2152ac327a27c4300a70795c90dbde2d">mUseAutoTextureMatrix</a>;
<a name="l00088"></a>00088 
<a name="l00090"></a><a class="code" href="classOgre_1_1GLES2RenderSystem.html#a31b482f041aac0af6320dba01e846278">00090</a>             <a class="code" href="classOgre_1_1GLES2Support.html">GLES2Support</a> *<a class="code" href="classOgre_1_1GLES2RenderSystem.html#a31b482f041aac0af6320dba01e846278" title="GL support class, used for creating windows etc.">mGLSupport</a>;
<a name="l00091"></a>00091 
<a name="l00092"></a>00092             <span class="comment">/* The main GL context - main thread only */</span>
<a name="l00093"></a><a class="code" href="classOgre_1_1GLES2RenderSystem.html#ada60566e5d37eb8100fde4b323fc4b42">00093</a>             <a class="code" href="classOgre_1_1GLES2Context.html" title="Class that encapsulates an GL context.">GLES2Context</a> *<a class="code" href="classOgre_1_1GLES2RenderSystem.html#ada60566e5d37eb8100fde4b323fc4b42">mMainContext</a>;
<a name="l00094"></a>00094 
<a name="l00095"></a>00095             <span class="comment">/* The current GL context  - main thread only */</span>
<a name="l00096"></a><a class="code" href="classOgre_1_1GLES2RenderSystem.html#a91e6f3f9238b22872f6e606f31db4cc9">00096</a>             <a class="code" href="classOgre_1_1GLES2Context.html" title="Class that encapsulates an GL context.">GLES2Context</a> *<a class="code" href="classOgre_1_1GLES2RenderSystem.html#a91e6f3f9238b22872f6e606f31db4cc9">mCurrentContext</a>;
<a name="l00097"></a><a class="code" href="classOgre_1_1GLES2RenderSystem.html#a7c5047b2b83160099d785bedcedaacea">00097</a>             <a class="code" href="classOgre_1_1GLES2GpuProgramManager.html">GLES2GpuProgramManager</a> *<a class="code" href="classOgre_1_1GLES2RenderSystem.html#a7c5047b2b83160099d785bedcedaacea">mGpuProgramManager</a>;
<a name="l00098"></a><a class="code" href="classOgre_1_1GLES2RenderSystem.html#a92bf926fd92a94f211c65686ed64cb78">00098</a>             <a class="code" href="classOgre_1_1GLSLESProgramFactory.html" title="Factory class for GLSL ES programs.">GLSLESProgramFactory</a>* <a class="code" href="classOgre_1_1GLES2RenderSystem.html#a92bf926fd92a94f211c65686ed64cb78">mGLSLESProgramFactory</a>;
<a name="l00099"></a>00099 <span class="preprocessor">#if !OGRE_NO_GLES2_CG_SUPPORT</span>
<a name="l00100"></a><a class="code" href="classOgre_1_1GLES2RenderSystem.html#a13180c5eab12fcb113e53c915568e1d4">00100</a> <span class="preprocessor"></span>            <a class="code" href="classOgre_1_1GLSLESCgProgramFactory.html" title="Factory class for GLSL ES programs.">GLSLESCgProgramFactory</a>* <a class="code" href="classOgre_1_1GLES2RenderSystem.html#a13180c5eab12fcb113e53c915568e1d4">mGLSLESCgProgramFactory</a>;
<a name="l00101"></a>00101 <span class="preprocessor">#endif</span>
<a name="l00102"></a><a class="code" href="classOgre_1_1GLES2RenderSystem.html#a37739fcea179ff4d0af7fe403213e1c5">00102</a> <span class="preprocessor"></span>            <a class="code" href="classOgre_1_1HardwareBufferManager.html" title="Singleton wrapper for hardware buffer manager.">HardwareBufferManager</a>* <a class="code" href="classOgre_1_1GLES2RenderSystem.html#a37739fcea179ff4d0af7fe403213e1c5">mHardwareBufferManager</a>;
<a name="l00103"></a>00103 
<a name="l00109"></a><a class="code" href="classOgre_1_1GLES2RenderSystem.html#a92ed8c065a6c9e51ac195253e58fbad0">00109</a>             <a class="code" href="classOgre_1_1GLES2RTTManager.html" title="Manager/factory for RenderTextures.">GLES2RTTManager</a> *<a class="code" href="classOgre_1_1GLES2RenderSystem.html#a92ed8c065a6c9e51ac195253e58fbad0" title="Manager object for creating render textures.">mRTTManager</a>;
<a name="l00110"></a>00110 
<a name="l00115"></a><a class="code" href="classOgre_1_1GLES2RenderSystem.html#aae4f856f88dadc499f90cdb00a360901">00115</a>             GLenum <a class="code" href="classOgre_1_1GLES2RenderSystem.html#aae4f856f88dadc499f90cdb00a360901" title="These variables are used for caching RenderSystem state.">mActiveTextureUnit</a>;
<a name="l00116"></a><a class="code" href="classOgre_1_1GLES2RenderSystem.html#a58561c8bb909db791726bb05d50b635c">00116</a>             <a class="code" href="classOgre_1_1GLES2RenderSystem.html#a8d12f2d55f7e1ac3b4e5b6c200a9322f">BindBufferMap</a> <a class="code" href="classOgre_1_1GLES2RenderSystem.html#a58561c8bb909db791726bb05d50b635c">mActiveBufferMap</a>;
<a name="l00117"></a>00117 
<a name="l00119"></a><a class="code" href="classOgre_1_1GLES2RenderSystem.html#a680a9a542fa62e71e8e15f1c53f33f52">00119</a>             <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1GLES2RenderSystem.html#a680a9a542fa62e71e8e15f1c53f33f52" title="Check if the GL system has already been initialised.">mGLInitialised</a>;
<a name="l00120"></a>00120 
<a name="l00122"></a><a class="code" href="classOgre_1_1GLES2RenderSystem.html#a917e16d41d6877b9755ae86f7dcfe24e">00122</a>             <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classOgre_1_1GLES2RenderSystem.html#a917e16d41d6877b9755ae86f7dcfe24e" title="Mask of buffers who contents can be discarded if GL_EXT_discard_framebuffer is supported.">mDiscardBuffers</a>;
<a name="l00123"></a>00123 
<a name="l00127"></a><a class="code" href="classOgre_1_1GLES2RenderSystem.html#af8eecf173f7e2d4dbcda46c5979b0465">00127</a>             GLenum <a class="code" href="classOgre_1_1GLES2RenderSystem.html#af8eecf173f7e2d4dbcda46c5979b0465" title="OpenGL ES doesn&#39;t support setting the PolygonMode like desktop GL So we will cache the value and set ...">mPolygonMode</a>;
<a name="l00128"></a>00128 
<a name="l00129"></a>00129             <span class="comment">// local data member of _render that were moved here to improve performance</span>
<a name="l00130"></a>00130             <span class="comment">// (save allocations)</span>
<a name="l00131"></a><a class="code" href="classOgre_1_1GLES2RenderSystem.html#a24300b939b938458f45b72e1f1575f29">00131</a>             <a class="code" href="structOgre_1_1vector.html">vector&lt;GLuint&gt;::type</a> <a class="code" href="classOgre_1_1GLES2RenderSystem.html#a24300b939b938458f45b72e1f1575f29">mRenderAttribsBound</a>;
<a name="l00132"></a>00132 
<a name="l00133"></a>00133             GLint getCombinedMinMipFilter(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00134"></a>00134 
<a name="l00135"></a><a class="code" href="classOgre_1_1GLES2RenderSystem.html#a488fb21934dd2f47c5ee5e2ab08e7342">00135</a>             <a class="code" href="classOgre_1_1GLES2GpuProgram.html" title="Generalised low-level GL program, can be applied to multiple types (eg ARB and NV)">GLES2GpuProgram</a>* <a class="code" href="classOgre_1_1GLES2RenderSystem.html#a488fb21934dd2f47c5ee5e2ab08e7342">mCurrentVertexProgram</a>;
<a name="l00136"></a><a class="code" href="classOgre_1_1GLES2RenderSystem.html#a3b52052fad4043b868bfd4f7fc2d767b">00136</a>             <a class="code" href="classOgre_1_1GLES2GpuProgram.html" title="Generalised low-level GL program, can be applied to multiple types (eg ARB and NV)">GLES2GpuProgram</a>* <a class="code" href="classOgre_1_1GLES2RenderSystem.html#a3b52052fad4043b868bfd4f7fc2d767b">mCurrentFragmentProgram</a>;
<a name="l00137"></a>00137 
<a name="l00138"></a>00138             GLint getTextureAddressingMode(<a class="code" href="classOgre_1_1TextureUnitState.html#a47c5a9f4fc08159b99bdc51103bcf852" title="Texture addressing modes - default is TAM_WRAP.">TextureUnitState::TextureAddressingMode</a> tam) <span class="keyword">const</span>;
<a name="l00139"></a>00139             GLenum getBlendMode(<a class="code" href="group__Materials.html#ga41c76d419d6c9c205a6c1d3b42872213" title="Blending factors for manually blending objects with the scene.">SceneBlendFactor</a> ogreBlend) <span class="keyword">const</span>;
<a name="l00140"></a>00140 
<a name="l00141"></a>00141             <span class="keywordtype">bool</span> activateGLTextureUnit(<span class="keywordtype">size_t</span> unit);
<a name="l00142"></a>00142 
<a name="l00143"></a>00143         <span class="keyword">public</span>:
<a name="l00144"></a>00144             <span class="comment">// Default constructor / destructor</span>
<a name="l00145"></a>00145             <a class="code" href="classOgre_1_1GLES2RenderSystem.html" title="Implementation of GL ES 2.x as a rendering system.">GLES2RenderSystem</a>();
<a name="l00146"></a>00146             <span class="keyword">virtual</span> ~<a class="code" href="classOgre_1_1GLES2RenderSystem.html" title="Implementation of GL ES 2.x as a rendering system.">GLES2RenderSystem</a>();
<a name="l00147"></a>00147         
<a name="l00148"></a><a class="code" href="classOgre_1_1GLES2RenderSystem.html#ae3fef941757423683223183c2374e5d9">00148</a>             <span class="keyword">friend</span> <span class="keyword">class </span>ShaderGeneratorTechniqueResolverListener;
<a name="l00149"></a>00149 
<a name="l00150"></a>00150             <span class="comment">// ----------------------------------</span>
<a name="l00151"></a>00151             <span class="comment">// Overridden RenderSystem functions</span>
<a name="l00152"></a>00152             <span class="comment">// ----------------------------------</span>
<a name="l00156"></a>00156 <span class="comment"></span>            <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; getName(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00160"></a>00160             <a class="code" href="group__General.html#gafba22dbf34cd07633293ddba65ee6add">ConfigOptionMap</a>&amp; getConfigOptions(<span class="keywordtype">void</span>);
<a name="l00164"></a>00164             <span class="keywordtype">void</span> setConfigOption(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;name, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;value);
<a name="l00168"></a>00168             <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> validateConfigOptions(<span class="keywordtype">void</span>);
<a name="l00172"></a>00172             <a class="code" href="classOgre_1_1RenderWindow.html" title="Manages the target rendering window.">RenderWindow</a>* _initialise(<span class="keywordtype">bool</span> autoCreateWindow, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; windowTitle = <span class="stringliteral">&quot;OGRE Render NativeWindowType&quot;</span>);
<a name="l00176"></a>00176             <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1RenderSystemCapabilities.html" title="singleton class for storing the capabilities of the graphics card.">RenderSystemCapabilities</a>* createRenderSystemCapabilities() <span class="keyword">const</span>;
<a name="l00180"></a>00180             <span class="keywordtype">void</span> initialiseFromRenderSystemCapabilities(<a class="code" href="classOgre_1_1RenderSystemCapabilities.html" title="singleton class for storing the capabilities of the graphics card.">RenderSystemCapabilities</a>* caps, <a class="code" href="classOgre_1_1RenderTarget.html" title="A &#39;canvas&#39; which can receive the results of a rendering operation.">RenderTarget</a>* primary);
<a name="l00184"></a>00184             <span class="keywordtype">void</span> reinitialise(<span class="keywordtype">void</span>); <span class="comment">// Used if settings changed mid-rendering</span>
<a name="l00188"></a>00188 <span class="comment"></span>            <span class="keywordtype">void</span> shutdown(<span class="keywordtype">void</span>);
<a name="l00192"></a><a class="code" href="classOgre_1_1GLES2RenderSystem.html#a1bc017b987519e2353066fc8bf7b7f9e">00192</a>             <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1GLES2RenderSystem.html#a1bc017b987519e2353066fc8bf7b7f9e" title="See RenderSystem.">setAmbientLight</a>(<span class="keywordtype">float</span> r, <span class="keywordtype">float</span> g, <span class="keywordtype">float</span> b) { };   <span class="comment">// Not supported</span>
<a name="l00196"></a><a class="code" href="classOgre_1_1GLES2RenderSystem.html#a2640f7587aa928791bd2099fdbd96c45">00196</a> <span class="comment"></span>            <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1GLES2RenderSystem.html#a2640f7587aa928791bd2099fdbd96c45" title="See RenderSystem.">setShadingType</a>(<a class="code" href="group__General.html#ga7afd4c7d428baaee13f3a0dbcae5f560" title="Light shading modes.">ShadeOptions</a> so) { };   <span class="comment">// Not supported</span>
<a name="l00200"></a><a class="code" href="classOgre_1_1GLES2RenderSystem.html#ab1066976c6333c4bc1b67645d8de9ff1">00200</a> <span class="comment"></span>            <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1GLES2RenderSystem.html#ab1066976c6333c4bc1b67645d8de9ff1" title="See RenderSystem.">setLightingEnabled</a>(<span class="keywordtype">bool</span> enabled) { };   <span class="comment">// Not supported</span>
<a name="l00201"></a>00201 
<a name="l00203"></a>00203             <a class="code" href="classOgre_1_1RenderWindow.html" title="Manages the target rendering window.">RenderWindow</a>* _createRenderWindow(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;name, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> width, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> height, 
<a name="l00204"></a>00204                 <span class="keywordtype">bool</span> fullScreen, <span class="keyword">const</span> <a class="code" href="group__General.html#gadccb207c184efc0a6fb2a00ab6320d19" title="Name / value parameter pair (first = name, second = value)">NameValuePairList</a> *miscParams = 0);
<a name="l00205"></a>00205 
<a name="l00207"></a>00207             <a class="code" href="classOgre_1_1DepthBuffer.html" title="An abstract class that contains a depth/stencil buffer.">DepthBuffer</a>* _createDepthBufferFor( <a class="code" href="classOgre_1_1RenderTarget.html" title="A &#39;canvas&#39; which can receive the results of a rendering operation.">RenderTarget</a> *renderTarget );
<a name="l00208"></a>00208 
<a name="l00210"></a>00210             <span class="keywordtype">void</span> _getDepthStencilFormatFor( GLenum internalColourFormat, GLenum *depthFormat,
<a name="l00211"></a>00211                                             GLenum *stencilFormat );
<a name="l00212"></a>00212 
<a name="l00214"></a>00214             <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1MultiRenderTarget.html" title="This class represents a render target that renders to multiple RenderTextures at once.">MultiRenderTarget</a> * createMultiRenderTarget(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp; name);
<a name="l00215"></a>00215 
<a name="l00219"></a>00219             <span class="keywordtype">void</span> destroyRenderWindow(<a class="code" href="classOgre_1_1RenderWindow.html" title="Manages the target rendering window.">RenderWindow</a>* pWin);
<a name="l00223"></a>00223             <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> getErrorDescription(<span class="keywordtype">long</span> errorNumber) <span class="keyword">const</span>;
<a name="l00227"></a>00227             <a class="code" href="group__RenderSystem.html#ga027109503a988ba85f4c63b55082907f" title="Vertex element type, used to identify the base types of the vertex contents.">VertexElementType</a> getColourVertexElementType(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00231"></a><a class="code" href="classOgre_1_1GLES2RenderSystem.html#a98ab9d3c273bf611e563f6b627b1b99d">00231</a>             <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1GLES2RenderSystem.html#a98ab9d3c273bf611e563f6b627b1b99d" title="See RenderSystem.">setNormaliseNormals</a>(<span class="keywordtype">bool</span> normalise) { };   <span class="comment">// Not supported</span>
<a name="l00232"></a>00232 
<a name="l00233"></a>00233             <span class="comment">// -----------------------------</span>
<a name="l00234"></a>00234             <span class="comment">// Low-level overridden members</span>
<a name="l00235"></a>00235             <span class="comment">// -----------------------------</span>
<a name="l00239"></a><a class="code" href="classOgre_1_1GLES2RenderSystem.html#a2e315afbf7cafe5456e0b7a128c72413">00239</a> <span class="comment"></span>            <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1GLES2RenderSystem.html#a2e315afbf7cafe5456e0b7a128c72413" title="See RenderSystem.">_useLights</a>(<span class="keyword">const</span> <a class="code" href="classOgre_1_1HashedVector.html">LightList</a>&amp; lights, <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> limit) { };   <span class="comment">// Not supported</span>
<a name="l00243"></a><a class="code" href="classOgre_1_1GLES2RenderSystem.html#a33873b6d680e3e820796ee227a34ebb4">00243</a> <span class="comment"></span>            <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1GLES2RenderSystem.html#a33873b6d680e3e820796ee227a34ebb4" title="See RenderSystem.">areFixedFunctionLightsInViewSpace</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <span class="keyword">true</span>; }
<a name="l00247"></a>00247             <span class="keywordtype">void</span> _setWorldMatrix(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Matrix4.html" title="Class encapsulating a standard 4x4 homogeneous matrix.">Matrix4</a> &amp;m);
<a name="l00251"></a>00251             <span class="keywordtype">void</span> _setViewMatrix(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Matrix4.html" title="Class encapsulating a standard 4x4 homogeneous matrix.">Matrix4</a> &amp;m);
<a name="l00255"></a>00255             <span class="keywordtype">void</span> _setProjectionMatrix(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Matrix4.html" title="Class encapsulating a standard 4x4 homogeneous matrix.">Matrix4</a> &amp;m);
<a name="l00259"></a><a class="code" href="classOgre_1_1GLES2RenderSystem.html#ad2f3dfdf32a348811bba87265f99384d">00259</a>             <span class="keywordtype">void</span> _setSurfaceParams(<span class="keyword">const</span> <a class="code" href="classOgre_1_1ColourValue.html" title="Class representing colour.">ColourValue</a> &amp;ambient,
<a name="l00260"></a>00260                                    <span class="keyword">const</span> <a class="code" href="classOgre_1_1ColourValue.html" title="Class representing colour.">ColourValue</a> &amp;diffuse, <span class="keyword">const</span> <a class="code" href="classOgre_1_1ColourValue.html" title="Class representing colour.">ColourValue</a> &amp;specular,
<a name="l00261"></a>00261                                    <span class="keyword">const</span> <a class="code" href="classOgre_1_1ColourValue.html" title="Class representing colour.">ColourValue</a> &amp;emissive, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> shininess,
<a name="l00262"></a>00262                                    <a class="code" href="group__General.html#gaf3fdba7211d7078a43201a1721532f9e" title="An enumeration describing which material properties should track the vertex colours.">TrackVertexColourType</a> tracking) {}
<a name="l00266"></a><a class="code" href="classOgre_1_1GLES2RenderSystem.html#a8ac94fc48eb2b3ff117e2e80db87e913">00266</a>             <span class="keywordtype">void</span> _setPointParameters(<a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> size, <span class="keywordtype">bool</span> attenuationEnabled,
<a name="l00267"></a>00267                                      <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> constant, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> linear, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> quadratic, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> minSize, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> maxSize) {}
<a name="l00271"></a><a class="code" href="classOgre_1_1GLES2RenderSystem.html#ac562ec602a4ab556c35c2b325dc6c8b0">00271</a>             <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1GLES2RenderSystem.html#ac562ec602a4ab556c35c2b325dc6c8b0" title="See RenderSystem.">_setPointSpritesEnabled</a>(<span class="keywordtype">bool</span> enabled) {}
<a name="l00275"></a>00275             <span class="keywordtype">void</span> _setTexture(<span class="keywordtype">size_t</span> unit, <span class="keywordtype">bool</span> enabled, <span class="keyword">const</span> <a class="code" href="classOgre_1_1TexturePtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to TexturePtr.">TexturePtr</a> &amp;tex);
<a name="l00279"></a>00279             <span class="keywordtype">void</span> _setTextureCoordSet(<span class="keywordtype">size_t</span> stage, <span class="keywordtype">size_t</span> index);
<a name="l00283"></a><a class="code" href="classOgre_1_1GLES2RenderSystem.html#ab365b7b0ee5b1d5ca492550cf0648f6f">00283</a>             <span class="keywordtype">void</span> _setTextureCoordCalculation(<span class="keywordtype">size_t</span> stage, <a class="code" href="group__RenderSystem.html#gaa9c06899edc6b7aed7bf3b29abe9bb31" title="Enum describing the ways to generate texture coordinates.">TexCoordCalcMethod</a> m,
<a name="l00284"></a>00284                     <span class="keyword">const</span> <a class="code" href="classOgre_1_1Frustum.html" title="A frustum represents a pyramid, capped at the near and far end which is used to represent either a vi...">Frustum</a>* frustum = 0) { };   <span class="comment">// Not supported</span>
<a name="l00288"></a><a class="code" href="classOgre_1_1GLES2RenderSystem.html#a3e12bab5f8d6ed5a8ed8a8698ce18ded">00288</a> <span class="comment"></span>            <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1GLES2RenderSystem.html#a3e12bab5f8d6ed5a8ed8a8698ce18ded" title="See RenderSystem.">_setTextureBlendMode</a>(<span class="keywordtype">size_t</span> stage, <span class="keyword">const</span> <a class="code" href="classOgre_1_1LayerBlendModeEx.html" title="Class which manages blending of both colour and alpha components.">LayerBlendModeEx</a>&amp; bm) { };   <span class="comment">// Not supported</span>
<a name="l00292"></a>00292 <span class="comment"></span>            <span class="keywordtype">void</span> _setTextureAddressingMode(<span class="keywordtype">size_t</span> stage, <span class="keyword">const</span> <a class="code" href="structOgre_1_1TextureUnitState_1_1UVWAddressingMode.html" title="Texture addressing mode for each texture coordinate.">TextureUnitState::UVWAddressingMode</a>&amp; uvw);
<a name="l00296"></a><a class="code" href="classOgre_1_1GLES2RenderSystem.html#a8f7d75c7234f300c1d6fdb09d019a3bc">00296</a>             <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1GLES2RenderSystem.html#a8f7d75c7234f300c1d6fdb09d019a3bc" title="See RenderSystem.">_setTextureBorderColour</a>(<span class="keywordtype">size_t</span> stage, <span class="keyword">const</span> <a class="code" href="classOgre_1_1ColourValue.html" title="Class representing colour.">ColourValue</a>&amp; colour) { };   <span class="comment">// Not supported</span>
<a name="l00300"></a><a class="code" href="classOgre_1_1GLES2RenderSystem.html#a9120c932b874e1fb8645035bbf22b65e">00300</a> <span class="comment"></span>            <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1GLES2RenderSystem.html#a9120c932b874e1fb8645035bbf22b65e" title="See RenderSystem.">_setTextureMipmapBias</a>(<span class="keywordtype">size_t</span> unit, <span class="keywordtype">float</span> bias) { };   <span class="comment">// Not supported</span>
<a name="l00304"></a><a class="code" href="classOgre_1_1GLES2RenderSystem.html#a5fa701746bf845b5a1c4c0508bb47bfb">00304</a> <span class="comment"></span>            <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1GLES2RenderSystem.html#a5fa701746bf845b5a1c4c0508bb47bfb" title="See RenderSystem.">_setTextureMatrix</a>(<span class="keywordtype">size_t</span> stage, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Matrix4.html" title="Class encapsulating a standard 4x4 homogeneous matrix.">Matrix4</a>&amp; xform) { };   <span class="comment">// Not supported</span>
<a name="l00308"></a>00308 <span class="comment"></span>            <span class="keywordtype">void</span> _setViewport(<a class="code" href="classOgre_1_1Viewport.html" title="An abstraction of a viewport, i.e.">Viewport</a> *vp);
<a name="l00312"></a>00312             <span class="keywordtype">void</span> _beginFrame(<span class="keywordtype">void</span>);
<a name="l00316"></a>00316             <span class="keywordtype">void</span> _endFrame(<span class="keywordtype">void</span>);
<a name="l00320"></a>00320             <span class="keywordtype">void</span> _setCullingMode(<a class="code" href="group__General.html#gac173244ed7d950d0acd726e4f323ecdb" title="Hardware culling modes based on vertex winding.">CullingMode</a> mode);
<a name="l00324"></a>00324             <span class="keywordtype">void</span> _setDepthBufferParams(<span class="keywordtype">bool</span> depthTest = <span class="keyword">true</span>, <span class="keywordtype">bool</span> depthWrite = <span class="keyword">true</span>, <a class="code" href="group__General.html#ga0212b4eb264f207d84c1df9425208c7a" title="Comparison functions used for the depth/stencil buffer operations and others.">CompareFunction</a> depthFunction = <a class="code" href="group__General.html#gga0212b4eb264f207d84c1df9425208c7aa2272d0faefcf5a2e08bbf7d232d7520b">CMPF_LESS_EQUAL</a>);
<a name="l00328"></a>00328             <span class="keywordtype">void</span> _setDepthBufferCheckEnabled(<span class="keywordtype">bool</span> enabled = <span class="keyword">true</span>);
<a name="l00332"></a>00332             <span class="keywordtype">void</span> _setDepthBufferWriteEnabled(<span class="keywordtype">bool</span> enabled = <span class="keyword">true</span>);
<a name="l00336"></a>00336             <span class="keywordtype">void</span> _setDepthBufferFunction(<a class="code" href="group__General.html#ga0212b4eb264f207d84c1df9425208c7a" title="Comparison functions used for the depth/stencil buffer operations and others.">CompareFunction</a> func = <a class="code" href="group__General.html#gga0212b4eb264f207d84c1df9425208c7aa2272d0faefcf5a2e08bbf7d232d7520b">CMPF_LESS_EQUAL</a>);
<a name="l00340"></a>00340             <span class="keywordtype">void</span> _setDepthBias(<span class="keywordtype">float</span> constantBias, <span class="keywordtype">float</span> slopeScaleBias);
<a name="l00344"></a>00344             <span class="keywordtype">void</span> _setColourBufferWriteEnabled(<span class="keywordtype">bool</span> red, <span class="keywordtype">bool</span> green, <span class="keywordtype">bool</span> blue, <span class="keywordtype">bool</span> alpha);
<a name="l00348"></a>00348             <span class="keywordtype">void</span> _setFog(<a class="code" href="group__General.html#ga83edeb2e5d33a3ca8f15834ba40020ba" title="Fog modes.">FogMode</a> mode, <span class="keyword">const</span> <a class="code" href="classOgre_1_1ColourValue.html" title="Class representing colour.">ColourValue</a>&amp; colour, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> density, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> start, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> end);
<a name="l00352"></a>00352             <span class="keywordtype">void</span> _convertProjectionMatrix(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Matrix4.html" title="Class encapsulating a standard 4x4 homogeneous matrix.">Matrix4</a>&amp; matrix,
<a name="l00353"></a>00353                     <a class="code" href="classOgre_1_1Matrix4.html" title="Class encapsulating a standard 4x4 homogeneous matrix.">Matrix4</a>&amp; dest, <span class="keywordtype">bool</span> forGpuProgram = <span class="keyword">false</span>);
<a name="l00357"></a>00357             <span class="keywordtype">void</span> _makeProjectionMatrix(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Radian.html" title="Wrapper class which indicates a given angle value is in Radians.">Radian</a>&amp; fovy, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> aspect, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> nearPlane, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> farPlane,
<a name="l00358"></a>00358                     <a class="code" href="classOgre_1_1Matrix4.html" title="Class encapsulating a standard 4x4 homogeneous matrix.">Matrix4</a>&amp; dest, <span class="keywordtype">bool</span> forGpuProgram = <span class="keyword">false</span>);
<a name="l00362"></a>00362             <span class="keywordtype">void</span> _makeProjectionMatrix(<a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> left, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> right, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> bottom, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> top, 
<a name="l00363"></a>00363                     <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> nearPlane, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> farPlane, <a class="code" href="classOgre_1_1Matrix4.html" title="Class encapsulating a standard 4x4 homogeneous matrix.">Matrix4</a>&amp; dest, <span class="keywordtype">bool</span> forGpuProgram = <span class="keyword">false</span>);
<a name="l00367"></a>00367             <span class="keywordtype">void</span> _makeOrthoMatrix(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Radian.html" title="Wrapper class which indicates a given angle value is in Radians.">Radian</a>&amp; fovy, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> aspect, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> nearPlane, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> farPlane,
<a name="l00368"></a>00368                     <a class="code" href="classOgre_1_1Matrix4.html" title="Class encapsulating a standard 4x4 homogeneous matrix.">Matrix4</a>&amp; dest, <span class="keywordtype">bool</span> forGpuProgram = <span class="keyword">false</span>);
<a name="l00372"></a>00372             <span class="keywordtype">void</span> _applyObliqueDepthProjection(<a class="code" href="classOgre_1_1Matrix4.html" title="Class encapsulating a standard 4x4 homogeneous matrix.">Matrix4</a>&amp; matrix, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Plane.html" title="Defines a plane in 3D space.">Plane</a>&amp; plane, 
<a name="l00373"></a>00373                     <span class="keywordtype">bool</span> forGpuProgram);
<a name="l00377"></a>00377             <span class="keywordtype">void</span> setClipPlane (<a class="code" href="namespaceOgre.html#af851e71354d841df7138f9877c6f5931">ushort</a> index, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> A, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> B, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> C, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> D);
<a name="l00381"></a>00381             <span class="keywordtype">void</span> enableClipPlane (<a class="code" href="namespaceOgre.html#af851e71354d841df7138f9877c6f5931">ushort</a> index, <span class="keywordtype">bool</span> enable);
<a name="l00385"></a>00385             <span class="keywordtype">void</span> _setPolygonMode(<a class="code" href="group__General.html#ga68866b02aa7f99e3431337511fbb3345" title="The polygon mode to use when rasterising.">PolygonMode</a> level);
<a name="l00389"></a>00389             <span class="keywordtype">void</span> setStencilCheckEnabled(<span class="keywordtype">bool</span> enabled);
<a name="l00393"></a>00393             <span class="keywordtype">void</span> setStencilBufferParams(<a class="code" href="group__General.html#ga0212b4eb264f207d84c1df9425208c7a" title="Comparison functions used for the depth/stencil buffer operations and others.">CompareFunction</a> func = <a class="code" href="group__General.html#gga0212b4eb264f207d84c1df9425208c7aae10ea1648cd8c9bd90bdaccaa11cbc4e">CMPF_ALWAYS_PASS</a>, 
<a name="l00394"></a>00394                     <a class="code" href="namespaceOgre.html#adf2a0cf2e77143b5ee1d38a75e289545">uint32</a> refValue = 0, <a class="code" href="namespaceOgre.html#adf2a0cf2e77143b5ee1d38a75e289545">uint32</a> mask = 0xFFFFFFFF,
<a name="l00395"></a>00395                     <a class="code" href="group__RenderSystem.html#gae8bb1cb809660de802d1d592ba4adb61" title="Enum describing the various actions which can be taken onthe stencil buffer.">StencilOperation</a> stencilFailOp = <a class="code" href="group__RenderSystem.html#ggae8bb1cb809660de802d1d592ba4adb61abf640cb28b5020509dc27178f0359511" title="Leave the stencil buffer unchanged.">SOP_KEEP</a>,
<a name="l00396"></a>00396                     <a class="code" href="group__RenderSystem.html#gae8bb1cb809660de802d1d592ba4adb61" title="Enum describing the various actions which can be taken onthe stencil buffer.">StencilOperation</a> depthFailOp = <a class="code" href="group__RenderSystem.html#ggae8bb1cb809660de802d1d592ba4adb61abf640cb28b5020509dc27178f0359511" title="Leave the stencil buffer unchanged.">SOP_KEEP</a>,
<a name="l00397"></a>00397                     <a class="code" href="group__RenderSystem.html#gae8bb1cb809660de802d1d592ba4adb61" title="Enum describing the various actions which can be taken onthe stencil buffer.">StencilOperation</a> passOp = <a class="code" href="group__RenderSystem.html#ggae8bb1cb809660de802d1d592ba4adb61abf640cb28b5020509dc27178f0359511" title="Leave the stencil buffer unchanged.">SOP_KEEP</a>,
<a name="l00398"></a>00398                     <span class="keywordtype">bool</span> twoSidedOperation = <span class="keyword">false</span>);
<a name="l00402"></a>00402             <span class="keywordtype">void</span> _setTextureUnitFiltering(<span class="keywordtype">size_t</span> unit, <a class="code" href="group__General.html#gac1fc36ec2f4df4b2afa9fa39f9c66c06">FilterType</a> ftype, <a class="code" href="group__General.html#ga02306c6246268d35f45ad22278bd5d3d" title="Filtering options for textures / mipmaps.">FilterOptions</a> filter);
<a name="l00406"></a>00406             <span class="keywordtype">void</span> _setTextureLayerAnisotropy(<span class="keywordtype">size_t</span> unit, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> maxAnisotropy);
<a name="l00410"></a><a class="code" href="classOgre_1_1GLES2RenderSystem.html#a66ae1fa73f7924a919f0052bb3759f36">00410</a>             <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1GLES2RenderSystem.html#a66ae1fa73f7924a919f0052bb3759f36" title="See RenderSystem.">setVertexDeclaration</a>(<a class="code" href="classOgre_1_1VertexDeclaration.html" title="This class declares the format of a set of vertex inputs, which can be issued to the rendering API th...">VertexDeclaration</a>* decl) {}
<a name="l00414"></a><a class="code" href="classOgre_1_1GLES2RenderSystem.html#a927adcc2b143aac311030958acf29c46">00414</a>             <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1GLES2RenderSystem.html#a927adcc2b143aac311030958acf29c46" title="See RenderSystem.">setVertexBufferBinding</a>(<a class="code" href="classOgre_1_1VertexBufferBinding.html" title="Records the state of all the vertex buffer bindings required to provide a vertex declaration with the...">VertexBufferBinding</a>* binding) {}
<a name="l00418"></a>00418             <span class="keywordtype">void</span> _render(<span class="keyword">const</span> <a class="code" href="classOgre_1_1RenderOperation.html" title="&#39;New&#39; rendering operation using vertex buffers.">RenderOperation</a>&amp; op);
<a name="l00422"></a>00422             <span class="keywordtype">void</span> setScissorTest(<span class="keywordtype">bool</span> enabled, <span class="keywordtype">size_t</span> left = 0, <span class="keywordtype">size_t</span> top = 0, <span class="keywordtype">size_t</span> right = 800, <span class="keywordtype">size_t</span> bottom = 600);
<a name="l00423"></a>00423         
<a name="l00424"></a><a class="code" href="classOgre_1_1GLES2RenderSystem.html#abee61e92687521761c5719399c23d15b">00424</a>             <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1GLES2RenderSystem.html#abee61e92687521761c5719399c23d15b">_setDiscardBuffers</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> flags) { mDiscardBuffers = flags; }
<a name="l00425"></a><a class="code" href="classOgre_1_1GLES2RenderSystem.html#a8fc24f90697ad297b653c55ef8caae25">00425</a>             <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classOgre_1_1GLES2RenderSystem.html#a8fc24f90697ad297b653c55ef8caae25">getDiscardBuffers</a>(<span class="keywordtype">void</span>) { <span class="keywordflow">return</span> mDiscardBuffers; }
<a name="l00426"></a>00426 
<a name="l00427"></a>00427             <span class="keywordtype">void</span> clearFrameBuffer(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> buffers,
<a name="l00428"></a>00428                 <span class="keyword">const</span> <a class="code" href="classOgre_1_1ColourValue.html" title="Class representing colour.">ColourValue</a>&amp; colour = <a class="code" href="classOgre_1_1ColourValue.html#a7f8a06f2a9dd645417c36b560f496c1a">ColourValue::Black</a>,
<a name="l00429"></a>00429                 <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> depth = 1.0f, <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> stencil = 0);
<a name="l00430"></a>00430             <a class="code" href="classOgre_1_1HardwareOcclusionQuery.html" title="This is a abstract class that that provides the interface for the query class for hardware occlusion...">HardwareOcclusionQuery</a>* createHardwareOcclusionQuery(<span class="keywordtype">void</span>);
<a name="l00431"></a><a class="code" href="classOgre_1_1GLES2RenderSystem.html#a1544a33adebe80158731c2da03215ff9">00431</a>             <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> <a class="code" href="classOgre_1_1GLES2RenderSystem.html#a1544a33adebe80158731c2da03215ff9" title="Returns the horizontal texel offset value required for mapping texel origins to pixel origins in this...">getHorizontalTexelOffset</a>(<span class="keywordtype">void</span>) { <span class="keywordflow">return</span> 0.0; }               <span class="comment">// No offset in GL</span>
<a name="l00432"></a><a class="code" href="classOgre_1_1GLES2RenderSystem.html#aaf0bf699528c28448b0b3941f21ea0a3">00432</a>             <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> <a class="code" href="classOgre_1_1GLES2RenderSystem.html#aaf0bf699528c28448b0b3941f21ea0a3" title="Returns the vertical texel offset value required for mapping texel origins to pixel origins in this r...">getVerticalTexelOffset</a>(<span class="keywordtype">void</span>) { <span class="keywordflow">return</span> 0.0; }                 <span class="comment">// No offset in GL</span>
<a name="l00433"></a><a class="code" href="classOgre_1_1GLES2RenderSystem.html#a383cd11d9747a823df91339d752dc971">00433</a>             <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> <a class="code" href="classOgre_1_1GLES2RenderSystem.html#a383cd11d9747a823df91339d752dc971" title="Gets the minimum (closest) depth value to be used when rendering using identity transforms.">getMinimumDepthInputValue</a>(<span class="keywordtype">void</span>) { <span class="keywordflow">return</span> -1.0f; }            <span class="comment">// Range [-1.0f, 1.0f]</span>
<a name="l00434"></a><a class="code" href="classOgre_1_1GLES2RenderSystem.html#aac9138fc73b0db8b05dad400e5d393e8">00434</a>             <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> <a class="code" href="classOgre_1_1GLES2RenderSystem.html#aac9138fc73b0db8b05dad400e5d393e8" title="Gets the maximum (farthest) depth value to be used when rendering using identity transforms.">getMaximumDepthInputValue</a>(<span class="keywordtype">void</span>) { <span class="keywordflow">return</span> 1.0f; }             <span class="comment">// Range [-1.0f, 1.0f]</span>
<a name="l00435"></a><a class="code" href="classOgre_1_1GLES2RenderSystem.html#af260eadeba4a0ef3e330a8c0ea73e606">00435</a>             <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1GLES2RenderSystem.html#af260eadeba4a0ef3e330a8c0ea73e606" title="Register the an additional thread which may make calls to rendersystem-related objects.">registerThread</a>() {}
<a name="l00436"></a><a class="code" href="classOgre_1_1GLES2RenderSystem.html#aa6bfad53622bb5f865871a3918bb4fac">00436</a>             <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1GLES2RenderSystem.html#aa6bfad53622bb5f865871a3918bb4fac" title="Unregister an additional thread which may make calls to rendersystem-related objects.">unregisterThread</a>() {}
<a name="l00437"></a><a class="code" href="classOgre_1_1GLES2RenderSystem.html#a8facb30ed47df20d9df6de77c23c5398">00437</a>             <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1GLES2RenderSystem.html#a8facb30ed47df20d9df6de77c23c5398" title="Tell the rendersystem to perform any prep tasks it needs to directly before other threads which might...">preExtraThreadsStarted</a>() {}
<a name="l00438"></a><a class="code" href="classOgre_1_1GLES2RenderSystem.html#a1767016ed55e3877d47464882aef9a27">00438</a>             <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1GLES2RenderSystem.html#a1767016ed55e3877d47464882aef9a27">postExtraThreadsStarted</a>() {}
<a name="l00439"></a><a class="code" href="classOgre_1_1GLES2RenderSystem.html#a2a7acd32e8329a1b59f40b7b7742dabf">00439</a>             <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1GLES2RenderSystem.html#a2a7acd32e8329a1b59f40b7b7742dabf" title="Internal method used to set the underlying clip planes when needed.">setClipPlanesImpl</a>(<span class="keyword">const</span> <a class="code" href="group__Math.html#gae00d718daa48567f6c010aad9d6dd92c">Ogre::PlaneList</a>&amp; planeList) {}
<a name="l00440"></a>00440 
<a name="l00441"></a>00441             <span class="comment">// ----------------------------------</span>
<a name="l00442"></a>00442             <span class="comment">// GLES2RenderSystem specific members</span>
<a name="l00443"></a>00443             <span class="comment">// ----------------------------------</span>
<a name="l00445"></a><a class="code" href="classOgre_1_1GLES2RenderSystem.html#a54e976f253252771af48b1fb50352d7f">00445</a> <span class="comment"></span>            <a class="code" href="classOgre_1_1GLES2Context.html" title="Class that encapsulates an GL context.">GLES2Context</a>* <a class="code" href="classOgre_1_1GLES2RenderSystem.html#a54e976f253252771af48b1fb50352d7f" title="Returns the main context.">_getMainContext</a>() { <span class="keywordflow">return</span> mMainContext; }
<a name="l00453"></a>00453             <span class="keywordtype">void</span> _unregisterContext(<a class="code" href="classOgre_1_1GLES2Context.html" title="Class that encapsulates an GL context.">GLES2Context</a> *context);
<a name="l00456"></a>00456             <span class="keywordtype">void</span> _switchContext(<a class="code" href="classOgre_1_1GLES2Context.html" title="Class that encapsulates an GL context.">GLES2Context</a> *context);
<a name="l00460"></a>00460             <span class="keywordtype">void</span> _oneTimeContextInitialization();
<a name="l00461"></a>00461             <span class="keywordtype">void</span> initialiseContext(<a class="code" href="classOgre_1_1RenderWindow.html" title="Manages the target rendering window.">RenderWindow</a>* primary);
<a name="l00465"></a>00465             <span class="keywordtype">void</span> _setRenderTarget(<a class="code" href="classOgre_1_1RenderTarget.html" title="A &#39;canvas&#39; which can receive the results of a rendering operation.">RenderTarget</a> *target);
<a name="l00466"></a>00466 
<a name="l00467"></a><a class="code" href="classOgre_1_1GLES2RenderSystem.html#ace4c5fe40bb2e8a4242fa8d204164e55">00467</a>             <a class="code" href="classOgre_1_1GLES2Support.html">GLES2Support</a>* <a class="code" href="classOgre_1_1GLES2RenderSystem.html#ace4c5fe40bb2e8a4242fa8d204164e55">getGLES2Support</a>() { <span class="keywordflow">return</span> mGLSupport; }
<a name="l00468"></a>00468             GLint convertCompareFunction(<a class="code" href="group__General.html#ga0212b4eb264f207d84c1df9425208c7a" title="Comparison functions used for the depth/stencil buffer operations and others.">CompareFunction</a> func) <span class="keyword">const</span>;
<a name="l00469"></a>00469             GLint convertStencilOp(<a class="code" href="group__RenderSystem.html#gae8bb1cb809660de802d1d592ba4adb61" title="Enum describing the various actions which can be taken onthe stencil buffer.">StencilOperation</a> op, <span class="keywordtype">bool</span> invert = <span class="keyword">false</span>) <span class="keyword">const</span>;
<a name="l00470"></a>00470 
<a name="l00471"></a>00471             <span class="keywordtype">void</span> bindGpuProgram(<a class="code" href="classOgre_1_1GpuProgram.html" title="Defines a program which runs on the GPU such as a vertex or fragment program.">GpuProgram</a>* prg);
<a name="l00472"></a>00472             <span class="keywordtype">void</span> unbindGpuProgram(<a class="code" href="group__Resources.html#gad08e89fa63e81d061ea9e2f37664976e" title="Enumerates the types of programs which can run on the GPU.">GpuProgramType</a> gptype);
<a name="l00473"></a>00473             <span class="keywordtype">void</span> bindGpuProgramParameters(<a class="code" href="group__Resources.html#gad08e89fa63e81d061ea9e2f37664976e" title="Enumerates the types of programs which can run on the GPU.">GpuProgramType</a> gptype, <a class="code" href="classOgre_1_1SharedPtr.html">GpuProgramParametersSharedPtr</a> params, <a class="code" href="namespaceOgre.html#aa8263b218e7d187ad5ef03a73a6ad7fd">uint16</a> mask);
<a name="l00474"></a>00474             <span class="keywordtype">void</span> bindGpuProgramPassIterationParameters(<a class="code" href="group__Resources.html#gad08e89fa63e81d061ea9e2f37664976e" title="Enumerates the types of programs which can run on the GPU.">GpuProgramType</a> gptype);
<a name="l00475"></a>00475 
<a name="l00477"></a>00477             <span class="keywordtype">void</span> _setSceneBlending( <a class="code" href="group__Materials.html#ga41c76d419d6c9c205a6c1d3b42872213" title="Blending factors for manually blending objects with the scene.">SceneBlendFactor</a> sourceFactor, <a class="code" href="group__Materials.html#ga41c76d419d6c9c205a6c1d3b42872213" title="Blending factors for manually blending objects with the scene.">SceneBlendFactor</a> destFactor, <a class="code" href="group__Materials.html#gaa7a12a72231aedf6e33d58aafc11214a" title="Blending operations controls how objects are blended into the scene.">SceneBlendOperation</a> op );
<a name="l00479"></a>00479             <span class="keywordtype">void</span> _setSeparateSceneBlending( <a class="code" href="group__Materials.html#ga41c76d419d6c9c205a6c1d3b42872213" title="Blending factors for manually blending objects with the scene.">SceneBlendFactor</a> sourceFactor, <a class="code" href="group__Materials.html#ga41c76d419d6c9c205a6c1d3b42872213" title="Blending factors for manually blending objects with the scene.">SceneBlendFactor</a> destFactor, <a class="code" href="group__Materials.html#ga41c76d419d6c9c205a6c1d3b42872213" title="Blending factors for manually blending objects with the scene.">SceneBlendFactor</a> sourceFactorAlpha, <a class="code" href="group__Materials.html#ga41c76d419d6c9c205a6c1d3b42872213" title="Blending factors for manually blending objects with the scene.">SceneBlendFactor</a> destFactorAlpha, <a class="code" href="group__Materials.html#gaa7a12a72231aedf6e33d58aafc11214a" title="Blending operations controls how objects are blended into the scene.">SceneBlendOperation</a> op, <a class="code" href="group__Materials.html#gaa7a12a72231aedf6e33d58aafc11214a" title="Blending operations controls how objects are blended into the scene.">SceneBlendOperation</a> alphaOp );
<a name="l00481"></a>00481             <span class="keywordtype">void</span> _setAlphaRejectSettings( <a class="code" href="group__General.html#ga0212b4eb264f207d84c1df9425208c7a" title="Comparison functions used for the depth/stencil buffer operations and others.">CompareFunction</a> func, <span class="keywordtype">unsigned</span> <span class="keywordtype">char</span> value, <span class="keywordtype">bool</span> alphaToCoverage );
<a name="l00483"></a>00483             <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> getDisplayMonitorCount() <span class="keyword">const</span>;
<a name="l00484"></a>00484 
<a name="l00486"></a>00486             GLfloat _getCurrentAnisotropy(<span class="keywordtype">size_t</span> unit);
<a name="l00487"></a>00487 
<a name="l00488"></a><a class="code" href="classOgre_1_1GLES2RenderSystem.html#a3626d32d82603e927505f334ba6687db">00488</a>             GLenum <a class="code" href="classOgre_1_1GLES2RenderSystem.html#a3626d32d82603e927505f334ba6687db">_getPolygonMode</a>(<span class="keywordtype">void</span>) { <span class="keywordflow">return</span> mPolygonMode; }
<a name="l00489"></a>00489 
<a name="l00490"></a>00490             <span class="keywordtype">void</span> _setSceneBlendingOperation(<a class="code" href="group__Materials.html#gaa7a12a72231aedf6e33d58aafc11214a" title="Blending operations controls how objects are blended into the scene.">SceneBlendOperation</a> op);
<a name="l00491"></a>00491             <span class="keywordtype">void</span> _setSeparateSceneBlendingOperation(<a class="code" href="group__Materials.html#gaa7a12a72231aedf6e33d58aafc11214a" title="Blending operations controls how objects are blended into the scene.">SceneBlendOperation</a> op, <a class="code" href="group__Materials.html#gaa7a12a72231aedf6e33d58aafc11214a" title="Blending operations controls how objects are blended into the scene.">SceneBlendOperation</a> alphaOp);
<a name="l00492"></a>00492 
<a name="l00493"></a>00493             <span class="keywordtype">void</span> _bindGLBuffer(GLenum target, GLuint buffer);
<a name="l00494"></a>00494             <span class="keywordtype">void</span> _deleteGLBuffer(GLenum target, GLuint buffer);
<a name="l00495"></a>00495     };
<a name="l00496"></a>00496 }
<a name="l00497"></a>00497 
<a name="l00498"></a>00498 <span class="preprocessor">#endif</span>
</pre></div></div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:48:50
</p>
</body>
</html>
